; ---------------------------------------------------------------
; Line count - compiled with PureBasic, Apr 19, 2009 
; counts LF characters in a file plus last line if without LF
; ---------------------------------------------------------------
#prog = "LineCount"
#Kb = 1024
#BufferSize = 200*#Kb

OpenConsole()
  
fname$ = ProgramParameter()

If ReadFile(0,fname$)
  SizeRemaining = Lof(0)
  LineCount = 0
  *Buffer = AllocateMemory(#BufferSize) 
  If *Buffer 
    While SizeRemaining > 0
      SizeRead = ReadData(0,*Buffer,#BufferSize) 
      LengthRemaining = 0
      EnableASM
      mov edi,*buffer
      mov ecx,SizeRead
      mov al,#LF
      !.rpt_cr:
      mov edx,edi
      repne scasb 
      jne .no_lf 
      inc LineCount 
      jecxz .done
      jmp .rpt_cr
      !.no_lf:
      sub edi,edx 
      mov LengthRemaining,edi
      !.done:
      DisableASM
      SizeRemaining - SizeRead
    Wend 
    If LengthRemaining : LineCount +1 : EndIf 
    PrintN(Str(LineCount) + " Lines")
    FreeMemory(*Buffer)
  Else 
    ConsoleError("Failed to allocate memory")
  EndIf 
  CloseFile(0)  
Else 
  ConsoleError("Cannot open file")
EndIf 
End

; IDE Options = PureBasic 4.30 (Windows - x86)
; ExecutableFormat = Console
; CursorPosition = 38
; FirstLine = 6
; Folding = -
; EnableXP
; Executable = LFcount.exe
; CompileSourceDirectory